"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_interfaces_1 = require("@0x/contracts-interfaces");
var contracts_test_utils_1 = require("@0x/contracts-test-utils");
var contracts_tokens_1 = require("@0x/contracts-tokens");
var dev_utils_1 = require("@0x/dev-utils");
var order_utils_1 = require("@0x/order-utils");
var types_1 = require("@0x/types");
var utils_1 = require("@0x/utils");
var chai = require("chai");
var _ = require("lodash");
var multi_asset_proxy_1 = require("../../generated-wrappers/multi_asset_proxy");
var artifacts_1 = require("../../src/artifacts");
var erc20_wrapper_1 = require("../utils/erc20_wrapper");
var erc721_wrapper_1 = require("../utils/erc721_wrapper");
contracts_test_utils_1.chaiSetup.configure();
var expect = chai.expect;
var blockchainLifecycle = new dev_utils_1.BlockchainLifecycle(contracts_test_utils_1.web3Wrapper);
var assetProxyInterface = new contracts_interfaces_1.IAssetProxyContract(contracts_interfaces_1.artifacts.IAssetProxy.compilerOutput.abi, contracts_test_utils_1.constants.NULL_ADDRESS, contracts_test_utils_1.provider);
var assetDataInterface = new contracts_interfaces_1.IAssetDataContract(contracts_interfaces_1.artifacts.IAssetData.compilerOutput.abi, contracts_test_utils_1.constants.NULL_ADDRESS, contracts_test_utils_1.provider);
// tslint:disable:no-unnecessary-type-assertion
describe('Asset Transfer Proxies', function () {
    var owner;
    var notAuthorized;
    var authorized;
    var fromAddress;
    var toAddress;
    var erc20TokenA;
    var erc20TokenB;
    var erc721TokenA;
    var erc721TokenB;
    var erc721Receiver;
    var erc20Proxy;
    var erc721Proxy;
    var noReturnErc20Token;
    var multipleReturnErc20Token;
    var multiAssetProxy;
    var erc20Wrapper;
    var erc721Wrapper;
    var erc721AFromTokenId;
    var erc721BFromTokenId;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        var _a, _b, _c, _d, accounts, usedAddresses, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, numDummyErc20ToDeploy, _u, _v, _w, _x, _y, _z, _0, _1, erc721Balances;
        return __generator(this, function (_2) {
            switch (_2.label) {
                case 0: return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.getAvailableAddressesAsync()];
                case 1:
                    accounts = _2.sent();
                    usedAddresses = (_a = _.slice(accounts, 0, 5), _b = __read(_a, 5), owner = _b[0], notAuthorized = _b[1], authorized = _b[2], fromAddress = _b[3], toAddress = _b[4], _a);
                    erc20Wrapper = new erc20_wrapper_1.ERC20Wrapper(contracts_test_utils_1.provider, usedAddresses, owner);
                    erc721Wrapper = new erc721_wrapper_1.ERC721Wrapper(contracts_test_utils_1.provider, usedAddresses, owner);
                    return [4 /*yield*/, erc20Wrapper.deployProxyAsync()];
                case 2:
                    // Deploy AssetProxies
                    erc20Proxy = _2.sent();
                    return [4 /*yield*/, erc721Wrapper.deployProxyAsync()];
                case 3:
                    erc721Proxy = _2.sent();
                    return [4 /*yield*/, multi_asset_proxy_1.MultiAssetProxyContract.deployFrom0xArtifactAsync(artifacts_1.artifacts.MultiAssetProxy, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults)];
                case 4:
                    multiAssetProxy = _2.sent();
                    _f = (_e = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc20Proxy.addAuthorizedAddress.sendTransactionAsync(authorized, {
                            from: owner,
                        })];
                case 5: 
                // Configure ERC20Proxy
                return [4 /*yield*/, _f.apply(_e, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 6:
                    // Configure ERC20Proxy
                    _2.sent();
                    _h = (_g = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc20Proxy.addAuthorizedAddress.sendTransactionAsync(multiAssetProxy.address, {
                            from: owner,
                        })];
                case 7: return [4 /*yield*/, _h.apply(_g, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 8:
                    _2.sent();
                    _k = (_j = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc721Proxy.addAuthorizedAddress.sendTransactionAsync(authorized, {
                            from: owner,
                        })];
                case 9: 
                // Configure ERC721Proxy
                return [4 /*yield*/, _k.apply(_j, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 10:
                    // Configure ERC721Proxy
                    _2.sent();
                    _m = (_l = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc721Proxy.addAuthorizedAddress.sendTransactionAsync(multiAssetProxy.address, {
                            from: owner,
                        })];
                case 11: return [4 /*yield*/, _m.apply(_l, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 12:
                    _2.sent();
                    _p = (_o = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, multiAssetProxy.addAuthorizedAddress.sendTransactionAsync(authorized, {
                            from: owner,
                        })];
                case 13: 
                // Configure MultiAssetProxy
                return [4 /*yield*/, _p.apply(_o, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 14:
                    // Configure MultiAssetProxy
                    _2.sent();
                    _r = (_q = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, multiAssetProxy.registerAssetProxy.sendTransactionAsync(erc20Proxy.address, {
                            from: owner,
                        })];
                case 15: return [4 /*yield*/, _r.apply(_q, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 16:
                    _2.sent();
                    _t = (_s = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, multiAssetProxy.registerAssetProxy.sendTransactionAsync(erc721Proxy.address, {
                            from: owner,
                        })];
                case 17: return [4 /*yield*/, _t.apply(_s, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 18:
                    _2.sent();
                    numDummyErc20ToDeploy = 2;
                    return [4 /*yield*/, erc20Wrapper.deployDummyTokensAsync(numDummyErc20ToDeploy, contracts_test_utils_1.constants.DUMMY_TOKEN_DECIMALS)];
                case 19:
                    _c = __read.apply(void 0, [_2.sent(), 2]), erc20TokenA = _c[0], erc20TokenB = _c[1];
                    return [4 /*yield*/, contracts_tokens_1.DummyNoReturnERC20TokenContract.deployFrom0xArtifactAsync(contracts_tokens_1.artifacts.DummyNoReturnERC20Token, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, contracts_test_utils_1.constants.DUMMY_TOKEN_NAME, contracts_test_utils_1.constants.DUMMY_TOKEN_SYMBOL, contracts_test_utils_1.constants.DUMMY_TOKEN_DECIMALS, contracts_test_utils_1.constants.DUMMY_TOKEN_TOTAL_SUPPLY)];
                case 20:
                    noReturnErc20Token = _2.sent();
                    return [4 /*yield*/, contracts_tokens_1.DummyMultipleReturnERC20TokenContract.deployFrom0xArtifactAsync(contracts_tokens_1.artifacts.DummyMultipleReturnERC20Token, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, contracts_test_utils_1.constants.DUMMY_TOKEN_NAME, contracts_test_utils_1.constants.DUMMY_TOKEN_SYMBOL, contracts_test_utils_1.constants.DUMMY_TOKEN_DECIMALS, contracts_test_utils_1.constants.DUMMY_TOKEN_TOTAL_SUPPLY)];
                case 21:
                    multipleReturnErc20Token = _2.sent();
                    return [4 /*yield*/, erc20Wrapper.setBalancesAndAllowancesAsync()];
                case 22:
                    _2.sent();
                    _v = (_u = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, noReturnErc20Token.setBalance.sendTransactionAsync(fromAddress, contracts_test_utils_1.constants.INITIAL_ERC20_BALANCE)];
                case 23: return [4 /*yield*/, _v.apply(_u, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 24:
                    _2.sent();
                    _x = (_w = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, noReturnErc20Token.approve.sendTransactionAsync(erc20Proxy.address, contracts_test_utils_1.constants.INITIAL_ERC20_ALLOWANCE, { from: fromAddress })];
                case 25: return [4 /*yield*/, _x.apply(_w, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 26:
                    _2.sent();
                    _z = (_y = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, multipleReturnErc20Token.setBalance.sendTransactionAsync(fromAddress, contracts_test_utils_1.constants.INITIAL_ERC20_BALANCE)];
                case 27: return [4 /*yield*/, _z.apply(_y, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 28:
                    _2.sent();
                    _1 = (_0 = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, multipleReturnErc20Token.approve.sendTransactionAsync(erc20Proxy.address, contracts_test_utils_1.constants.INITIAL_ERC20_ALLOWANCE, { from: fromAddress })];
                case 29: return [4 /*yield*/, _1.apply(_0, [_2.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 30:
                    _2.sent();
                    return [4 /*yield*/, erc721Wrapper.deployDummyTokensAsync()];
                case 31:
                    // Deploy and configure ERC721 tokens and receiver
                    _d = __read.apply(void 0, [_2.sent(), 2]), erc721TokenA = _d[0], erc721TokenB = _d[1];
                    return [4 /*yield*/, contracts_tokens_1.DummyERC721ReceiverContract.deployFrom0xArtifactAsync(contracts_tokens_1.artifacts.DummyERC721Receiver, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults)];
                case 32:
                    erc721Receiver = _2.sent();
                    return [4 /*yield*/, erc721Wrapper.setBalancesAndAllowancesAsync()];
                case 33:
                    _2.sent();
                    return [4 /*yield*/, erc721Wrapper.getBalancesAsync()];
                case 34:
                    erc721Balances = _2.sent();
                    erc721AFromTokenId = erc721Balances[fromAddress][erc721TokenA.address][0];
                    erc721BFromTokenId = erc721Balances[fromAddress][erc721TokenB.address][0];
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('ERC20Proxy', function () {
        it('should revert if undefined function is called', function () { return __awaiter(_this, void 0, void 0, function () {
            var undefinedSelector;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        undefinedSelector = '0x01020304';
                        return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedWithoutReasonAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                from: owner,
                                to: erc20Proxy.address,
                                value: contracts_test_utils_1.constants.ZERO_AMOUNT,
                                data: undefinedSelector,
                            }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should have an id of 0xf47261b0', function () { return __awaiter(_this, void 0, void 0, function () {
            var proxyId, expectedProxyId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, erc20Proxy.getProxyId.callAsync()];
                    case 1:
                        proxyId = _a.sent();
                        expectedProxyId = '0xf47261b0';
                        expect(proxyId).to.equal(expectedProxyId);
                        return [2 /*return*/];
                }
            });
        }); });
        describe('transferFrom', function () {
            it('should successfully transfer tokens', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, erc20Balances, amount, data, _a, _b, newBalances;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(amount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(amount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer tokens that do not return a value', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, initialFromBalance, initialToBalance, amount, data, _a, _b, newFromBalance, newToBalance;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(noReturnErc20Token.address);
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(fromAddress)];
                        case 1:
                            initialFromBalance = _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(toAddress)];
                        case 2:
                            initialToBalance = _c.sent();
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 3: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 4:
                            _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(fromAddress)];
                        case 5:
                            newFromBalance = _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(toAddress)];
                        case 6:
                            newToBalance = _c.sent();
                            expect(newFromBalance).to.be.bignumber.equal(initialFromBalance.minus(amount));
                            expect(newToBalance).to.be.bignumber.equal(initialToBalance.plus(amount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer tokens and ignore extra assetData', function () { return __awaiter(_this, void 0, void 0, function () {
                var extraData, encodedAssetData, erc20Balances, amount, data, _a, _b, newBalances;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            extraData = '0102030405060708';
                            encodedAssetData = "" + order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address) + extraData;
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(amount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(amount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should do nothing if transferring 0 amount of a token', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, erc20Balances, amount, data, _a, _b, newBalances;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            amount = new utils_1.BigNumber(0);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address]);
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address]);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if allowances are too low', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, allowance, amount, data, _a, _b, erc20Balances, newBalances;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            allowance = new utils_1.BigNumber(0);
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, erc20TokenA.approve.sendTransactionAsync(erc20Proxy.address, allowance, {
                                    from: fromAddress,
                                })];
                        case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 2:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 3:
                            erc20Balances = _c.sent();
                            // Perform a transfer; expect this to fail.
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.TransferFailed)];
                        case 4:
                            // Perform a transfer; expect this to fail.
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 5:
                            newBalances = _c.sent();
                            expect(newBalances).to.deep.equal(erc20Balances);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if allowances are too low and token does not return a value', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, allowance, amount, data, _a, _b, initialFromBalance, initialToBalance, newFromBalance, newToBalance;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(noReturnErc20Token.address);
                            allowance = new utils_1.BigNumber(0);
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, noReturnErc20Token.approve.sendTransactionAsync(erc20Proxy.address, allowance, {
                                    from: fromAddress,
                                })];
                        case 1: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 2:
                            _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(fromAddress)];
                        case 3:
                            initialFromBalance = _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(toAddress)];
                        case 4:
                            initialToBalance = _c.sent();
                            // Perform a transfer; expect this to fail.
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.TransferFailed)];
                        case 5:
                            // Perform a transfer; expect this to fail.
                            _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(fromAddress)];
                        case 6:
                            newFromBalance = _c.sent();
                            return [4 /*yield*/, noReturnErc20Token.balanceOf.callAsync(toAddress)];
                        case 7:
                            newToBalance = _c.sent();
                            expect(newFromBalance).to.be.bignumber.equal(initialFromBalance);
                            expect(newToBalance).to.be.bignumber.equal(initialToBalance);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if caller is not authorized', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, amount, data, erc20Balances, newBalances;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _a.sent();
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: notAuthorized,
                                }), types_1.RevertReason.SenderNotAuthorized)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 3:
                            newBalances = _a.sent();
                            expect(newBalances).to.deep.equal(erc20Balances);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if token returns more than 32 bytes', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, amount, data, initialFromBalance, initialToBalance, newFromBalance, newToBalance;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(multipleReturnErc20Token.address);
                            amount = new utils_1.BigNumber(10);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            return [4 /*yield*/, multipleReturnErc20Token.balanceOf.callAsync(fromAddress)];
                        case 1:
                            initialFromBalance = _a.sent();
                            return [4 /*yield*/, multipleReturnErc20Token.balanceOf.callAsync(toAddress)];
                        case 2:
                            initialToBalance = _a.sent();
                            // Perform a transfer; expect this to fail.
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc20Proxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.TransferFailed)];
                        case 3:
                            // Perform a transfer; expect this to fail.
                            _a.sent();
                            return [4 /*yield*/, multipleReturnErc20Token.balanceOf.callAsync(fromAddress)];
                        case 4:
                            newFromBalance = _a.sent();
                            return [4 /*yield*/, multipleReturnErc20Token.balanceOf.callAsync(toAddress)];
                        case 5:
                            newToBalance = _a.sent();
                            expect(newFromBalance).to.be.bignumber.equal(initialFromBalance);
                            expect(newToBalance).to.be.bignumber.equal(initialToBalance);
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
    describe('ERC721Proxy', function () {
        it('should revert if undefined function is called', function () { return __awaiter(_this, void 0, void 0, function () {
            var undefinedSelector;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        undefinedSelector = '0x01020304';
                        return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedWithoutReasonAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                from: owner,
                                to: erc721Proxy.address,
                                value: contracts_test_utils_1.constants.ZERO_AMOUNT,
                                data: undefinedSelector,
                            }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should have an id of 0x02571792', function () { return __awaiter(_this, void 0, void 0, function () {
            var proxyId, expectedProxyId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, erc721Proxy.getProxyId.callAsync()];
                    case 1:
                        proxyId = _a.sent();
                        expectedProxyId = '0x02571792';
                        expect(proxyId).to.equal(expectedProxyId);
                        return [2 /*return*/];
                }
            });
        }); });
        describe('transferFrom', function () {
            it('should successfully transfer tokens', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, ownerFromAsset, amount, data, _a, _b, newOwnerFromAsset;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            amount = new utils_1.BigNumber(1);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 4:
                            newOwnerFromAsset = _c.sent();
                            expect(newOwnerFromAsset).to.be.bignumber.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer tokens and ignore extra assetData', function () { return __awaiter(_this, void 0, void 0, function () {
                var extraData, encodedAssetData, ownerFromAsset, amount, data, _a, _b, newOwnerFromAsset;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            extraData = '0102030405060708';
                            encodedAssetData = "" + order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId) + extraData;
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            amount = new utils_1.BigNumber(1);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 4:
                            newOwnerFromAsset = _c.sent();
                            expect(newOwnerFromAsset).to.be.bignumber.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should not call onERC721Received when transferring to a smart contract', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, ownerFromAsset, amount, data, logDecoder, tx, _a, _b, newOwnerFromAsset;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            amount = new utils_1.BigNumber(1);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, erc721Receiver.address, amount);
                            logDecoder = new contracts_test_utils_1.LogDecoder(contracts_test_utils_1.web3Wrapper, __assign({}, artifacts_1.artifacts, contracts_tokens_1.artifacts));
                            _b = (_a = logDecoder).getTxWithDecodedLogsAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: authorized,
                                    gas: contracts_test_utils_1.constants.MAX_TRANSFER_FROM_GAS,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent()])];
                        case 3:
                            tx = _c.sent();
                            // Verify that no log was emitted by erc721 receiver
                            expect(tx.logs.length).to.be.equal(1);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 4:
                            newOwnerFromAsset = _c.sent();
                            expect(newOwnerFromAsset).to.be.bignumber.equal(erc721Receiver.address);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if transferring 0 amount of a token', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, ownerFromAsset, amount, data, newOwner;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _a.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            amount = new utils_1.BigNumber(0);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.InvalidAmount)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 3:
                            newOwner = _a.sent();
                            expect(newOwner).to.be.equal(ownerFromAsset);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if transferring > 1 amount of a token', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, ownerFromAsset, amount, data, newOwner;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _a.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            amount = new utils_1.BigNumber(500);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.InvalidAmount)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 3:
                            newOwner = _a.sent();
                            expect(newOwner).to.be.equal(ownerFromAsset);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if allowances are too low', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, ownerFromAsset, _a, _b, amount, data, newOwner;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, erc721TokenA.approve.sendTransactionAsync(contracts_test_utils_1.constants.NULL_ADDRESS, erc721AFromTokenId, {
                                    from: fromAddress,
                                })];
                        case 2: 
                        // Remove transfer approval for fromAddress.
                        return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            // Remove transfer approval for fromAddress.
                            _c.sent();
                            amount = new utils_1.BigNumber(1);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.TransferFailed)];
                        case 4:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 5:
                            newOwner = _c.sent();
                            expect(newOwner).to.be.equal(ownerFromAsset);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if caller is not authorized', function () { return __awaiter(_this, void 0, void 0, function () {
                var encodedAssetData, ownerFromAsset, amount, data, newOwner;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            encodedAssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _a.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            amount = new utils_1.BigNumber(1);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(encodedAssetData, fromAddress, toAddress, amount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: erc721Proxy.address,
                                    data: data,
                                    from: notAuthorized,
                                }), types_1.RevertReason.SenderNotAuthorized)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 3:
                            newOwner = _a.sent();
                            expect(newOwner).to.be.equal(ownerFromAsset);
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
    describe('MultiAssetProxy', function () {
        it('should revert if undefined function is called', function () { return __awaiter(_this, void 0, void 0, function () {
            var undefinedSelector;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        undefinedSelector = '0x01020304';
                        return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedWithoutReasonAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                from: owner,
                                to: multiAssetProxy.address,
                                value: contracts_test_utils_1.constants.ZERO_AMOUNT,
                                data: undefinedSelector,
                            }))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should have an id of 0x94cfcdd7', function () { return __awaiter(_this, void 0, void 0, function () {
            var proxyId, expectedProxyId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, multiAssetProxy.getProxyId.callAsync()];
                    case 1:
                        proxyId = _a.sent();
                        expectedProxyId = '0x94cfcdd7';
                        expect(proxyId).to.equal(expectedProxyId);
                        return [2 /*return*/];
                }
            });
        }); });
        describe('transferFrom', function () {
            it('should transfer a single ERC20 token', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, amounts, nestedAssetData, assetData, data, erc20Balances, _a, _b, newBalances, totalAmount;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            amounts = [erc20Amount];
                            nestedAssetData = [erc20AssetData];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            totalAmount = inputAmount.times(erc20Amount);
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalAmount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should dispatch an ERC20 transfer when input amount is 0', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, amounts, nestedAssetData, assetData, data, erc20Balances, logDecoder, tx, _a, _b, log, transferEventName, newBalances;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = contracts_test_utils_1.constants.ZERO_AMOUNT;
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            amounts = [erc20Amount];
                            nestedAssetData = [erc20AssetData];
                            assetData = assetDataInterface.MultiAsset.getABIEncodedTransactionData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            logDecoder = new contracts_test_utils_1.LogDecoder(contracts_test_utils_1.web3Wrapper, __assign({}, artifacts_1.artifacts, contracts_tokens_1.artifacts));
                            _b = (_a = logDecoder).getTxWithDecodedLogsAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent()])];
                        case 3:
                            tx = _c.sent();
                            expect(tx.logs.length).to.be.equal(1);
                            log = tx.logs[0];
                            transferEventName = 'Transfer';
                            expect(log.event).to.equal(transferEventName);
                            expect(log.args._value).to.be.bignumber.equal(contracts_test_utils_1.constants.ZERO_AMOUNT);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            expect(newBalances).to.deep.equal(erc20Balances);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer multiple of the same ERC20 token', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount1, erc20Amount2, erc20AssetData1, erc20AssetData2, amounts, nestedAssetData, assetData, data, erc20Balances, _a, _b, newBalances, totalAmount;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount1 = new utils_1.BigNumber(10);
                            erc20Amount2 = new utils_1.BigNumber(20);
                            erc20AssetData1 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc20AssetData2 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            amounts = [erc20Amount1, erc20Amount2];
                            nestedAssetData = [erc20AssetData1, erc20AssetData2];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            totalAmount = inputAmount.times(erc20Amount1).plus(inputAmount.times(erc20Amount2));
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalAmount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer multiple different ERC20 tokens', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount1, erc20Amount2, erc20AssetData1, erc20AssetData2, amounts, nestedAssetData, assetData, data, erc20Balances, _a, _b, newBalances, totalErc20AAmount, totalErc20BAmount;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount1 = new utils_1.BigNumber(10);
                            erc20Amount2 = new utils_1.BigNumber(20);
                            erc20AssetData1 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc20AssetData2 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenB.address);
                            amounts = [erc20Amount1, erc20Amount2];
                            nestedAssetData = [erc20AssetData1, erc20AssetData2];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            totalErc20AAmount = inputAmount.times(erc20Amount1);
                            totalErc20BAmount = inputAmount.times(erc20Amount2);
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalErc20AAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalErc20AAmount));
                            expect(newBalances[fromAddress][erc20TokenB.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenB.address].minus(totalErc20BAmount));
                            expect(newBalances[toAddress][erc20TokenB.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenB.address].add(totalErc20BAmount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should transfer a single ERC721 token', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc721Amount, erc721AssetData, amounts, nestedAssetData, assetData, data, ownerFromAsset, _a, _b, newOwnerFromAsset;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc721Amount = new utils_1.BigNumber(1);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            amounts = [erc721Amount];
                            nestedAssetData = [erc721AssetData];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 4:
                            newOwnerFromAsset = _c.sent();
                            expect(newOwnerFromAsset).to.be.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer multiple of the same ERC721 token', function () { return __awaiter(_this, void 0, void 0, function () {
                var erc721Balances, erc721AFromTokenId2, erc721AssetData1, erc721AssetData2, inputAmount, erc721Amount, amounts, nestedAssetData, assetData, data, ownerFromAsset1, ownerFromAsset2, _a, _b, newOwnerFromAsset1, newOwnerFromAsset2;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, erc721Wrapper.getBalancesAsync()];
                        case 1:
                            erc721Balances = _c.sent();
                            erc721AFromTokenId2 = erc721Balances[fromAddress][erc721TokenA.address][1];
                            erc721AssetData1 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            erc721AssetData2 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId2);
                            inputAmount = new utils_1.BigNumber(1);
                            erc721Amount = new utils_1.BigNumber(1);
                            amounts = [erc721Amount, erc721Amount];
                            nestedAssetData = [erc721AssetData1, erc721AssetData2];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 2:
                            ownerFromAsset1 = _c.sent();
                            expect(ownerFromAsset1).to.be.equal(fromAddress);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId2)];
                        case 3:
                            ownerFromAsset2 = _c.sent();
                            expect(ownerFromAsset2).to.be.equal(fromAddress);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                    gas: contracts_test_utils_1.constants.MAX_TRANSFER_FROM_GAS,
                                })];
                        case 4: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 5:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 6:
                            newOwnerFromAsset1 = _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId2)];
                        case 7:
                            newOwnerFromAsset2 = _c.sent();
                            expect(newOwnerFromAsset1).to.be.equal(toAddress);
                            expect(newOwnerFromAsset2).to.be.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer multiple different ERC721 tokens', function () { return __awaiter(_this, void 0, void 0, function () {
                var erc721AssetData1, erc721AssetData2, inputAmount, erc721Amount, amounts, nestedAssetData, assetData, data, ownerFromAsset1, ownerFromAsset2, _a, _b, newOwnerFromAsset1, newOwnerFromAsset2;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            erc721AssetData1 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            erc721AssetData2 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenB.address, erc721BFromTokenId);
                            inputAmount = new utils_1.BigNumber(1);
                            erc721Amount = new utils_1.BigNumber(1);
                            amounts = [erc721Amount, erc721Amount];
                            nestedAssetData = [erc721AssetData1, erc721AssetData2];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 1:
                            ownerFromAsset1 = _c.sent();
                            expect(ownerFromAsset1).to.be.equal(fromAddress);
                            return [4 /*yield*/, erc721TokenB.ownerOf.callAsync(erc721BFromTokenId)];
                        case 2:
                            ownerFromAsset2 = _c.sent();
                            expect(ownerFromAsset2).to.be.equal(fromAddress);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                    gas: contracts_test_utils_1.constants.MAX_TRANSFER_FROM_GAS,
                                })];
                        case 3: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 4:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 5:
                            newOwnerFromAsset1 = _c.sent();
                            return [4 /*yield*/, erc721TokenB.ownerOf.callAsync(erc721BFromTokenId)];
                        case 6:
                            newOwnerFromAsset2 = _c.sent();
                            expect(newOwnerFromAsset1).to.be.equal(toAddress);
                            expect(newOwnerFromAsset2).to.be.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer a combination of ERC20 and ERC721 tokens', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721Amount, erc721AssetData, amounts, nestedAssetData, assetData, data, erc20Balances, ownerFromAsset, _a, _b, newBalances, totalAmount, newOwnerFromAsset;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721Amount = new utils_1.BigNumber(1);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            amounts = [erc20Amount, erc721Amount];
                            nestedAssetData = [erc20AssetData, erc721AssetData];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 2:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 3: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 4:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 5:
                            newBalances = _c.sent();
                            totalAmount = inputAmount.times(erc20Amount);
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalAmount));
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 6:
                            newOwnerFromAsset = _c.sent();
                            expect(newOwnerFromAsset).to.be.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer tokens and ignore extra assetData', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721Amount, erc721AssetData, amounts, nestedAssetData, extraData, assetData, data, erc20Balances, ownerFromAsset, _a, _b, newBalances, totalAmount, newOwnerFromAsset;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721Amount = new utils_1.BigNumber(1);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            amounts = [erc20Amount, erc721Amount];
                            nestedAssetData = [erc20AssetData, erc721AssetData];
                            extraData = '0102030405060708';
                            assetData = "" + order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData) + extraData;
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 2:
                            ownerFromAsset = _c.sent();
                            expect(ownerFromAsset).to.be.equal(fromAddress);
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 3: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 4:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 5:
                            newBalances = _c.sent();
                            totalAmount = inputAmount.times(erc20Amount);
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalAmount));
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 6:
                            newOwnerFromAsset = _c.sent();
                            expect(newOwnerFromAsset).to.be.equal(toAddress);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer correct amounts when the `amount` > 1', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount1, erc20Amount2, erc20AssetData1, erc20AssetData2, amounts, nestedAssetData, assetData, data, erc20Balances, _a, _b, newBalances, totalErc20AAmount, totalErc20BAmount;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(100);
                            erc20Amount1 = new utils_1.BigNumber(10);
                            erc20Amount2 = new utils_1.BigNumber(20);
                            erc20AssetData1 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc20AssetData2 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenB.address);
                            amounts = [erc20Amount1, erc20Amount2];
                            nestedAssetData = [erc20AssetData1, erc20AssetData2];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 1:
                            erc20Balances = _c.sent();
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                })];
                        case 2: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 3:
                            _c.sent();
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 4:
                            newBalances = _c.sent();
                            totalErc20AAmount = inputAmount.times(erc20Amount1);
                            totalErc20BAmount = inputAmount.times(erc20Amount2);
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalErc20AAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalErc20AAmount));
                            expect(newBalances[fromAddress][erc20TokenB.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenB.address].minus(totalErc20BAmount));
                            expect(newBalances[toAddress][erc20TokenB.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenB.address].add(totalErc20BAmount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should successfully transfer a large amount of tokens', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount1, erc20Amount2, erc20AssetData1, erc20AssetData2, erc721Amount, erc721Balances, erc721AFromTokenId2, erc721BFromTokenId2, erc721AssetData1, erc721AssetData2, erc721AssetData3, erc721AssetData4, amounts, nestedAssetData, assetData, data, ownerFromAsset1, ownerFromAsset2, ownerFromAsset3, ownerFromAsset4, erc20Balances, _a, _b, newOwnerFromAsset1, newOwnerFromAsset2, newOwnerFromAsset3, newOwnerFromAsset4, newBalances, totalErc20AAmount, totalErc20BAmount;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount1 = new utils_1.BigNumber(10);
                            erc20Amount2 = new utils_1.BigNumber(20);
                            erc20AssetData1 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc20AssetData2 = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenB.address);
                            erc721Amount = new utils_1.BigNumber(1);
                            return [4 /*yield*/, erc721Wrapper.getBalancesAsync()];
                        case 1:
                            erc721Balances = _c.sent();
                            erc721AFromTokenId2 = erc721Balances[fromAddress][erc721TokenA.address][1];
                            erc721BFromTokenId2 = erc721Balances[fromAddress][erc721TokenB.address][1];
                            erc721AssetData1 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            erc721AssetData2 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId2);
                            erc721AssetData3 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenB.address, erc721BFromTokenId);
                            erc721AssetData4 = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenB.address, erc721BFromTokenId2);
                            amounts = [erc721Amount, erc20Amount1, erc721Amount, erc20Amount2, erc721Amount, erc721Amount];
                            nestedAssetData = [
                                erc721AssetData1,
                                erc20AssetData1,
                                erc721AssetData2,
                                erc20AssetData2,
                                erc721AssetData3,
                                erc721AssetData4,
                            ];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 2:
                            ownerFromAsset1 = _c.sent();
                            expect(ownerFromAsset1).to.be.equal(fromAddress);
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId2)];
                        case 3:
                            ownerFromAsset2 = _c.sent();
                            expect(ownerFromAsset2).to.be.equal(fromAddress);
                            return [4 /*yield*/, erc721TokenB.ownerOf.callAsync(erc721BFromTokenId)];
                        case 4:
                            ownerFromAsset3 = _c.sent();
                            expect(ownerFromAsset3).to.be.equal(fromAddress);
                            return [4 /*yield*/, erc721TokenB.ownerOf.callAsync(erc721BFromTokenId2)];
                        case 5:
                            ownerFromAsset4 = _c.sent();
                            expect(ownerFromAsset4).to.be.equal(fromAddress);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 6:
                            erc20Balances = _c.sent();
                            _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                            return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                    gas: contracts_test_utils_1.constants.MAX_EXECUTE_TRANSACTION_GAS,
                                })];
                        case 7: return [4 /*yield*/, _b.apply(_a, [_c.sent(),
                                contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                        case 8:
                            _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId)];
                        case 9:
                            newOwnerFromAsset1 = _c.sent();
                            return [4 /*yield*/, erc721TokenA.ownerOf.callAsync(erc721AFromTokenId2)];
                        case 10:
                            newOwnerFromAsset2 = _c.sent();
                            return [4 /*yield*/, erc721TokenB.ownerOf.callAsync(erc721BFromTokenId)];
                        case 11:
                            newOwnerFromAsset3 = _c.sent();
                            return [4 /*yield*/, erc721TokenB.ownerOf.callAsync(erc721BFromTokenId2)];
                        case 12:
                            newOwnerFromAsset4 = _c.sent();
                            expect(newOwnerFromAsset1).to.be.equal(toAddress);
                            expect(newOwnerFromAsset2).to.be.equal(toAddress);
                            expect(newOwnerFromAsset3).to.be.equal(toAddress);
                            expect(newOwnerFromAsset4).to.be.equal(toAddress);
                            return [4 /*yield*/, erc20Wrapper.getBalancesAsync()];
                        case 13:
                            newBalances = _c.sent();
                            totalErc20AAmount = inputAmount.times(erc20Amount1);
                            totalErc20BAmount = inputAmount.times(erc20Amount2);
                            expect(newBalances[fromAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenA.address].minus(totalErc20AAmount));
                            expect(newBalances[toAddress][erc20TokenA.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenA.address].add(totalErc20AAmount));
                            expect(newBalances[fromAddress][erc20TokenB.address]).to.be.bignumber.equal(erc20Balances[fromAddress][erc20TokenB.address].minus(totalErc20BAmount));
                            expect(newBalances[toAddress][erc20TokenB.address]).to.be.bignumber.equal(erc20Balances[toAddress][erc20TokenB.address].add(totalErc20BAmount));
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if a single transfer fails', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721Amount, erc721AssetData, amounts, nestedAssetData, assetData, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721Amount = new utils_1.BigNumber(2);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            amounts = [erc20Amount, erc721Amount];
                            nestedAssetData = [erc20AssetData, erc721AssetData];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.InvalidAmount)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if an AssetProxy is not registered', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721Amount, erc721AssetData, invalidProxyId, invalidErc721AssetData, amounts, nestedAssetData, assetData, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721Amount = new utils_1.BigNumber(1);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            invalidProxyId = '0x12345678';
                            invalidErc721AssetData = "" + invalidProxyId + erc721AssetData.slice(10);
                            amounts = [erc20Amount, erc721Amount];
                            nestedAssetData = [erc20AssetData, invalidErc721AssetData];
                            assetData = assetDataInterface.MultiAsset.getABIEncodedTransactionData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.AssetProxyDoesNotExist)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if the length of `amounts` does not match the length of `nestedAssetData`', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721AssetData, amounts, nestedAssetData, assetData, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            amounts = [erc20Amount];
                            nestedAssetData = [erc20AssetData, erc721AssetData];
                            assetData = assetDataInterface.MultiAsset.getABIEncodedTransactionData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.LengthMismatch)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if amounts multiplication results in an overflow', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, amounts, nestedAssetData, assetData, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(2).pow(128);
                            erc20Amount = new utils_1.BigNumber(2).pow(128);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            amounts = [erc20Amount];
                            nestedAssetData = [erc20AssetData];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.Uint256Overflow)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if an element of `nestedAssetData` is < 4 bytes long', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721Amount, erc721AssetData, amounts, nestedAssetData, assetData, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721Amount = new utils_1.BigNumber(1);
                            erc721AssetData = '0x123456';
                            amounts = [erc20Amount, erc721Amount];
                            nestedAssetData = [erc20AssetData, erc721AssetData];
                            assetData = assetDataInterface.MultiAsset.getABIEncodedTransactionData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: authorized,
                                }), types_1.RevertReason.LengthGreaterThan3Required)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if caller is not authorized', function () { return __awaiter(_this, void 0, void 0, function () {
                var inputAmount, erc20Amount, erc20AssetData, erc721Amount, erc721AssetData, amounts, nestedAssetData, assetData, data;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            inputAmount = new utils_1.BigNumber(1);
                            erc20Amount = new utils_1.BigNumber(10);
                            erc20AssetData = order_utils_1.assetDataUtils.encodeERC20AssetData(erc20TokenA.address);
                            erc721Amount = new utils_1.BigNumber(1);
                            erc721AssetData = order_utils_1.assetDataUtils.encodeERC721AssetData(erc721TokenA.address, erc721AFromTokenId);
                            amounts = [erc20Amount, erc721Amount];
                            nestedAssetData = [erc20AssetData, erc721AssetData];
                            assetData = order_utils_1.assetDataUtils.encodeMultiAssetData(amounts, nestedAssetData);
                            data = assetProxyInterface.transferFrom.getABIEncodedTransactionData(assetData, fromAddress, toAddress, inputAmount);
                            return [4 /*yield*/, contracts_test_utils_1.expectTransactionFailedAsync(contracts_test_utils_1.web3Wrapper.sendTransactionAsync({
                                    to: multiAssetProxy.address,
                                    data: data,
                                    from: notAuthorized,
                                }), types_1.RevertReason.SenderNotAuthorized)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            }); });
        });
    });
});
// tslint:enable:no-unnecessary-type-assertion
// tslint:disable:max-file-line-count
//# sourceMappingURL=proxies.js.map