"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_test_utils_1 = require("@0x/contracts-test-utils");
var dev_utils_1 = require("@0x/dev-utils");
var types_1 = require("@0x/types");
var utils_1 = require("@0x/utils");
var chai = require("chai");
var asset_proxy_owner_1 = require("../../generated-wrappers/asset_proxy_owner");
var mixin_authorizable_1 = require("../../generated-wrappers/mixin_authorizable");
var test_asset_proxy_owner_1 = require("../../generated-wrappers/test_asset_proxy_owner");
var artifacts_1 = require("../../src/artifacts");
var asset_proxy_owner_wrapper_1 = require("../utils/asset_proxy_owner_wrapper");
contracts_test_utils_1.chaiSetup.configure();
var expect = chai.expect;
var blockchainLifecycle = new dev_utils_1.BlockchainLifecycle(contracts_test_utils_1.web3Wrapper);
// tslint:disable:no-unnecessary-type-assertion
describe('AssetProxyOwner', function () {
    var owners;
    var authorized;
    var notOwner;
    var REQUIRED_APPROVALS = new utils_1.BigNumber(2);
    var SECONDS_TIME_LOCKED = new utils_1.BigNumber(1000000);
    var erc20Proxy;
    var erc721Proxy;
    var testAssetProxyOwner;
    var assetProxyOwnerWrapper;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    after(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        var accounts, initialOwner, defaultAssetProxyContractAddresses, _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0: return [4 /*yield*/, contracts_test_utils_1.web3Wrapper.getAvailableAddressesAsync()];
                case 1:
                    accounts = _e.sent();
                    owners = [accounts[0], accounts[1]];
                    authorized = accounts[2];
                    notOwner = accounts[3];
                    initialOwner = accounts[0];
                    return [4 /*yield*/, mixin_authorizable_1.MixinAuthorizableContract.deployFrom0xArtifactAsync(artifacts_1.artifacts.MixinAuthorizable, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults)];
                case 2:
                    erc20Proxy = _e.sent();
                    return [4 /*yield*/, mixin_authorizable_1.MixinAuthorizableContract.deployFrom0xArtifactAsync(artifacts_1.artifacts.MixinAuthorizable, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults)];
                case 3:
                    erc721Proxy = _e.sent();
                    defaultAssetProxyContractAddresses = [];
                    return [4 /*yield*/, test_asset_proxy_owner_1.TestAssetProxyOwnerContract.deployFrom0xArtifactAsync(artifacts_1.artifacts.TestAssetProxyOwner, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, owners, defaultAssetProxyContractAddresses, REQUIRED_APPROVALS, SECONDS_TIME_LOCKED)];
                case 4:
                    testAssetProxyOwner = _e.sent();
                    assetProxyOwnerWrapper = new asset_proxy_owner_wrapper_1.AssetProxyOwnerWrapper(testAssetProxyOwner, contracts_test_utils_1.provider);
                    _b = (_a = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc20Proxy.transferOwnership.sendTransactionAsync(testAssetProxyOwner.address, {
                            from: initialOwner,
                        })];
                case 5: return [4 /*yield*/, _b.apply(_a, [_e.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 6:
                    _e.sent();
                    _d = (_c = contracts_test_utils_1.web3Wrapper).awaitTransactionSuccessAsync;
                    return [4 /*yield*/, erc721Proxy.transferOwnership.sendTransactionAsync(testAssetProxyOwner.address, {
                            from: initialOwner,
                        })];
                case 7: return [4 /*yield*/, _d.apply(_c, [_e.sent(),
                        contracts_test_utils_1.constants.AWAIT_TRANSACTION_MINED_MS])];
                case 8:
                    _e.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    beforeEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.startAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    afterEach(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, blockchainLifecycle.revertAsync()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    describe('constructor', function () {
        it('should register passed in assetProxyContracts', function () { return __awaiter(_this, void 0, void 0, function () {
            var assetProxyContractAddresses, newMultiSig, isErc20ProxyRegistered, isErc721ProxyRegistered;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        assetProxyContractAddresses = [erc20Proxy.address, erc721Proxy.address];
                        return [4 /*yield*/, asset_proxy_owner_1.AssetProxyOwnerContract.deployFrom0xArtifactAsync(artifacts_1.artifacts.AssetProxyOwner, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, owners, assetProxyContractAddresses, REQUIRED_APPROVALS, SECONDS_TIME_LOCKED)];
                    case 1:
                        newMultiSig = _a.sent();
                        return [4 /*yield*/, newMultiSig.isAssetProxyRegistered.callAsync(erc20Proxy.address)];
                    case 2:
                        isErc20ProxyRegistered = _a.sent();
                        return [4 /*yield*/, newMultiSig.isAssetProxyRegistered.callAsync(erc721Proxy.address)];
                    case 3:
                        isErc721ProxyRegistered = _a.sent();
                        expect(isErc20ProxyRegistered).to.equal(true);
                        expect(isErc721ProxyRegistered).to.equal(true);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should throw if a null address is included in assetProxyContracts', function () { return __awaiter(_this, void 0, void 0, function () {
            var assetProxyContractAddresses;
            return __generator(this, function (_a) {
                assetProxyContractAddresses = [erc20Proxy.address, contracts_test_utils_1.constants.NULL_ADDRESS];
                return [2 /*return*/, contracts_test_utils_1.expectContractCreationFailedAsync(asset_proxy_owner_1.AssetProxyOwnerContract.deployFrom0xArtifactAsync(artifacts_1.artifacts.AssetProxyOwner, contracts_test_utils_1.provider, contracts_test_utils_1.txDefaults, owners, assetProxyContractAddresses, REQUIRED_APPROVALS, SECONDS_TIME_LOCKED), types_1.RevertReason.InvalidAssetProxy)];
            });
        }); });
    });
    describe('isFunctionRemoveAuthorizedAddressAtIndex', function () {
        it('should return false if data is not for removeAuthorizedAddressAtIndex', function () { return __awaiter(_this, void 0, void 0, function () {
            var notRemoveAuthorizedAddressData, isFunctionRemoveAuthorizedAddressAtIndex;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        notRemoveAuthorizedAddressData = erc20Proxy.addAuthorizedAddress.getABIEncodedTransactionData(owners[0]);
                        return [4 /*yield*/, testAssetProxyOwner.isFunctionRemoveAuthorizedAddressAtIndex.callAsync(notRemoveAuthorizedAddressData)];
                    case 1:
                        isFunctionRemoveAuthorizedAddressAtIndex = _a.sent();
                        expect(isFunctionRemoveAuthorizedAddressAtIndex).to.be.false();
                        return [2 /*return*/];
                }
            });
        }); });
        it('should return true if data is for removeAuthorizedAddressAtIndex', function () { return __awaiter(_this, void 0, void 0, function () {
            var index, removeAuthorizedAddressAtIndexData, isFunctionRemoveAuthorizedAddressAtIndex;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        index = new utils_1.BigNumber(0);
                        removeAuthorizedAddressAtIndexData = erc20Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(owners[0], index);
                        return [4 /*yield*/, testAssetProxyOwner.isFunctionRemoveAuthorizedAddressAtIndex.callAsync(removeAuthorizedAddressAtIndexData)];
                    case 1:
                        isFunctionRemoveAuthorizedAddressAtIndex = _a.sent();
                        expect(isFunctionRemoveAuthorizedAddressAtIndex).to.be.true();
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('registerAssetProxy', function () {
        it('should throw if not called by multisig', function () { return __awaiter(_this, void 0, void 0, function () {
            var isRegistered;
            return __generator(this, function (_a) {
                isRegistered = true;
                return [2 /*return*/, contracts_test_utils_1.expectTransactionFailedWithoutReasonAsync(testAssetProxyOwner.registerAssetProxy.sendTransactionAsync(erc20Proxy.address, isRegistered, {
                        from: owners[0],
                    }))];
            });
        }); });
        it('should register an address if called by multisig after timelock', function () { return __awaiter(_this, void 0, void 0, function () {
            var addressToRegister, isRegistered, registerAssetProxyData, submitTxRes, log, txId, executeTxRes, registerLog, isAssetProxyRegistered;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        addressToRegister = erc20Proxy.address;
                        isRegistered = true;
                        registerAssetProxyData = testAssetProxyOwner.registerAssetProxy.getABIEncodedTransactionData(addressToRegister, isRegistered);
                        return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(testAssetProxyOwner.address, registerAssetProxyData, owners[0])];
                    case 1:
                        submitTxRes = _a.sent();
                        log = submitTxRes.logs[0];
                        txId = log.args.transactionId;
                        return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, contracts_test_utils_1.increaseTimeAndMineBlockAsync(SECONDS_TIME_LOCKED.toNumber())];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.executeTransactionAsync(txId, owners[0])];
                    case 4:
                        executeTxRes = _a.sent();
                        registerLog = executeTxRes.logs[0];
                        expect(registerLog.args.assetProxyContract).to.equal(addressToRegister);
                        expect(registerLog.args.isRegistered).to.equal(isRegistered);
                        return [4 /*yield*/, testAssetProxyOwner.isAssetProxyRegistered.callAsync(addressToRegister)];
                    case 5:
                        isAssetProxyRegistered = _a.sent();
                        expect(isAssetProxyRegistered).to.equal(isRegistered);
                        return [2 /*return*/];
                }
            });
        }); });
        it('should fail if registering a null address', function () { return __awaiter(_this, void 0, void 0, function () {
            var addressToRegister, isRegistered, registerAssetProxyData, submitTxRes, log, txId, executeTxRes, failureLog, isAssetProxyRegistered;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        addressToRegister = contracts_test_utils_1.constants.NULL_ADDRESS;
                        isRegistered = true;
                        registerAssetProxyData = testAssetProxyOwner.registerAssetProxy.getABIEncodedTransactionData(addressToRegister, isRegistered);
                        return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(testAssetProxyOwner.address, registerAssetProxyData, owners[0])];
                    case 1:
                        submitTxRes = _a.sent();
                        log = submitTxRes.logs[0];
                        txId = log.args.transactionId;
                        return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, contracts_test_utils_1.increaseTimeAndMineBlockAsync(SECONDS_TIME_LOCKED.toNumber())];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.executeTransactionAsync(txId, owners[0])];
                    case 4:
                        executeTxRes = _a.sent();
                        failureLog = executeTxRes.logs[0];
                        expect(failureLog.args.transactionId).to.be.bignumber.equal(txId);
                        return [4 /*yield*/, testAssetProxyOwner.isAssetProxyRegistered.callAsync(addressToRegister)];
                    case 5:
                        isAssetProxyRegistered = _a.sent();
                        expect(isAssetProxyRegistered).to.equal(false);
                        return [2 /*return*/];
                }
            });
        }); });
    });
    describe('Calling removeAuthorizedAddressAtIndex', function () {
        var erc20Index = new utils_1.BigNumber(0);
        var erc721Index = new utils_1.BigNumber(1);
        before('authorize both proxies and register erc20 proxy', function () { return __awaiter(_this, void 0, void 0, function () {
            var addressToRegister, isRegistered, registerAssetProxyData, registerAssetProxySubmitRes, registerAssetProxySubmitLog, addAuthorizedAddressData, erc20AddAuthorizedAddressSubmitRes, erc721AddAuthorizedAddressSubmitRes, erc20AddAuthorizedAddressSubmitLog, erc721AddAuthorizedAddressSubmitLog, registerAssetProxyTxId, erc20AddAuthorizedAddressTxId, erc721AddAuthorizedAddressTxId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        addressToRegister = erc20Proxy.address;
                        isRegistered = true;
                        registerAssetProxyData = testAssetProxyOwner.registerAssetProxy.getABIEncodedTransactionData(addressToRegister, isRegistered);
                        return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(testAssetProxyOwner.address, registerAssetProxyData, owners[0])];
                    case 1:
                        registerAssetProxySubmitRes = _a.sent();
                        registerAssetProxySubmitLog = registerAssetProxySubmitRes.logs[0];
                        addAuthorizedAddressData = erc20Proxy.addAuthorizedAddress.getABIEncodedTransactionData(authorized);
                        return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, addAuthorizedAddressData, owners[0])];
                    case 2:
                        erc20AddAuthorizedAddressSubmitRes = _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc721Proxy.address, addAuthorizedAddressData, owners[0])];
                    case 3:
                        erc721AddAuthorizedAddressSubmitRes = _a.sent();
                        erc20AddAuthorizedAddressSubmitLog = erc20AddAuthorizedAddressSubmitRes.logs[0];
                        erc721AddAuthorizedAddressSubmitLog = erc721AddAuthorizedAddressSubmitRes
                            .logs[0];
                        registerAssetProxyTxId = registerAssetProxySubmitLog.args.transactionId;
                        erc20AddAuthorizedAddressTxId = erc20AddAuthorizedAddressSubmitLog.args.transactionId;
                        erc721AddAuthorizedAddressTxId = erc721AddAuthorizedAddressSubmitLog.args.transactionId;
                        return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(registerAssetProxyTxId, owners[1])];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(erc20AddAuthorizedAddressTxId, owners[1])];
                    case 5:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(erc721AddAuthorizedAddressTxId, owners[1])];
                    case 6:
                        _a.sent();
                        return [4 /*yield*/, contracts_test_utils_1.increaseTimeAndMineBlockAsync(SECONDS_TIME_LOCKED.toNumber())];
                    case 7:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.executeTransactionAsync(registerAssetProxyTxId, owners[0])];
                    case 8:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.executeTransactionAsync(erc20AddAuthorizedAddressTxId, owners[0], {
                                gas: contracts_test_utils_1.constants.MAX_EXECUTE_TRANSACTION_GAS,
                            })];
                    case 9:
                        _a.sent();
                        return [4 /*yield*/, assetProxyOwnerWrapper.executeTransactionAsync(erc721AddAuthorizedAddressTxId, owners[0], {
                                gas: contracts_test_utils_1.constants.MAX_EXECUTE_TRANSACTION_GAS,
                            })];
                    case 10:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        describe('validRemoveAuthorizedAddressAtIndexTx', function () {
            it('should revert if data is not for removeAuthorizedAddressAtIndex and proxy is registered', function () { return __awaiter(_this, void 0, void 0, function () {
                var notRemoveAuthorizedAddressData, submitTxRes, log, txId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            notRemoveAuthorizedAddressData = erc20Proxy.addAuthorizedAddress.getABIEncodedTransactionData(authorized);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, notRemoveAuthorizedAddressData, owners[0])];
                        case 1:
                            submitTxRes = _a.sent();
                            log = submitTxRes.logs[0];
                            txId = log.args.transactionId;
                            return [2 /*return*/, contracts_test_utils_1.expectContractCallFailedAsync(testAssetProxyOwner.testValidRemoveAuthorizedAddressAtIndexTx.callAsync(txId), types_1.RevertReason.InvalidFunctionSelector)];
                    }
                });
            }); });
            it('should return true if data is for removeAuthorizedAddressAtIndex and proxy is registered', function () { return __awaiter(_this, void 0, void 0, function () {
                var removeAuthorizedAddressAtIndexData, submitTxRes, log, txId, isValidRemoveAuthorizedAddressAtIndexTx;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            removeAuthorizedAddressAtIndexData = erc20Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc20Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 1:
                            submitTxRes = _a.sent();
                            log = submitTxRes.logs[0];
                            txId = log.args.transactionId;
                            return [4 /*yield*/, testAssetProxyOwner.testValidRemoveAuthorizedAddressAtIndexTx.callAsync(txId)];
                        case 2:
                            isValidRemoveAuthorizedAddressAtIndexTx = _a.sent();
                            expect(isValidRemoveAuthorizedAddressAtIndexTx).to.be.true();
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should revert if data is for removeAuthorizedAddressAtIndex and proxy is not registered', function () { return __awaiter(_this, void 0, void 0, function () {
                var removeAuthorizedAddressAtIndexData, submitTxRes, log, txId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            removeAuthorizedAddressAtIndexData = erc721Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc721Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc721Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 1:
                            submitTxRes = _a.sent();
                            log = submitTxRes.logs[0];
                            txId = log.args.transactionId;
                            return [2 /*return*/, contracts_test_utils_1.expectContractCallFailedAsync(testAssetProxyOwner.testValidRemoveAuthorizedAddressAtIndexTx.callAsync(txId), types_1.RevertReason.UnregisteredAssetProxy)];
                    }
                });
            }); });
        });
        describe('executeRemoveAuthorizedAddressAtIndex', function () {
            it('should throw without the required confirmations', function () { return __awaiter(_this, void 0, void 0, function () {
                var removeAuthorizedAddressAtIndexData, res, log, txId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            removeAuthorizedAddressAtIndexData = erc20Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc20Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 1:
                            res = _a.sent();
                            log = res.logs[0];
                            txId = log.args.transactionId;
                            return [2 /*return*/, contracts_test_utils_1.expectTransactionFailedAsync(testAssetProxyOwner.executeRemoveAuthorizedAddressAtIndex.sendTransactionAsync(txId, {
                                    from: owners[1],
                                }), types_1.RevertReason.TxNotFullyConfirmed)];
                    }
                });
            }); });
            it('should throw if tx destination is not registered', function () { return __awaiter(_this, void 0, void 0, function () {
                var removeAuthorizedAddressAtIndexData, res, log, txId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            removeAuthorizedAddressAtIndexData = erc721Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc721Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc721Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 1:
                            res = _a.sent();
                            log = res.logs[0];
                            txId = log.args.transactionId;
                            return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                        case 2:
                            _a.sent();
                            return [2 /*return*/, contracts_test_utils_1.expectTransactionFailedAsync(testAssetProxyOwner.executeRemoveAuthorizedAddressAtIndex.sendTransactionAsync(txId, {
                                    from: owners[1],
                                }), types_1.RevertReason.UnregisteredAssetProxy)];
                    }
                });
            }); });
            it('should throw if tx data is not for removeAuthorizedAddressAtIndex', function () { return __awaiter(_this, void 0, void 0, function () {
                var newAuthorized, addAuthorizedAddressData, res, log, txId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            newAuthorized = owners[1];
                            addAuthorizedAddressData = erc20Proxy.addAuthorizedAddress.getABIEncodedTransactionData(newAuthorized);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, addAuthorizedAddressData, owners[0])];
                        case 1:
                            res = _a.sent();
                            log = res.logs[0];
                            txId = log.args.transactionId;
                            return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                        case 2:
                            _a.sent();
                            return [2 /*return*/, contracts_test_utils_1.expectTransactionFailedAsync(testAssetProxyOwner.executeRemoveAuthorizedAddressAtIndex.sendTransactionAsync(txId, {
                                    from: owners[1],
                                }), types_1.RevertReason.InvalidFunctionSelector)];
                    }
                });
            }); });
            it('should execute removeAuthorizedAddressAtIndex for registered address if fully confirmed and called by owner', function () { return __awaiter(_this, void 0, void 0, function () {
                var isAuthorizedBefore, removeAuthorizedAddressAtIndexData, submitRes, submitLog, txId, execRes, execLog, tx, isExecuted, isAuthorizedAfter;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, erc20Proxy.authorized.callAsync(authorized)];
                        case 1:
                            isAuthorizedBefore = _a.sent();
                            expect(isAuthorizedBefore).to.equal(true);
                            removeAuthorizedAddressAtIndexData = erc20Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc20Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 2:
                            submitRes = _a.sent();
                            submitLog = submitRes.logs[0];
                            txId = submitLog.args.transactionId;
                            return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, assetProxyOwnerWrapper.executeRemoveAuthorizedAddressAtIndexAsync(txId, owners[0])];
                        case 4:
                            execRes = _a.sent();
                            execLog = execRes.logs[1];
                            expect(execLog.args.transactionId).to.be.bignumber.equal(txId);
                            return [4 /*yield*/, testAssetProxyOwner.transactions.callAsync(txId)];
                        case 5:
                            tx = _a.sent();
                            isExecuted = tx[3];
                            expect(isExecuted).to.equal(true);
                            return [4 /*yield*/, erc20Proxy.authorized.callAsync(authorized)];
                        case 6:
                            isAuthorizedAfter = _a.sent();
                            expect(isAuthorizedAfter).to.equal(false);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should execute removeAuthorizedAddressAtIndex for registered address if fully confirmed and called by non-owner', function () { return __awaiter(_this, void 0, void 0, function () {
                var isAuthorizedBefore, removeAuthorizedAddressAtIndexData, submitRes, submitLog, txId, execRes, execLog, tx, isExecuted, isAuthorizedAfter;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, erc20Proxy.authorized.callAsync(authorized)];
                        case 1:
                            isAuthorizedBefore = _a.sent();
                            expect(isAuthorizedBefore).to.equal(true);
                            removeAuthorizedAddressAtIndexData = erc20Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc20Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 2:
                            submitRes = _a.sent();
                            submitLog = submitRes.logs[0];
                            txId = submitLog.args.transactionId;
                            return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, assetProxyOwnerWrapper.executeRemoveAuthorizedAddressAtIndexAsync(txId, notOwner)];
                        case 4:
                            execRes = _a.sent();
                            execLog = execRes.logs[1];
                            expect(execLog.args.transactionId).to.be.bignumber.equal(txId);
                            return [4 /*yield*/, testAssetProxyOwner.transactions.callAsync(txId)];
                        case 5:
                            tx = _a.sent();
                            isExecuted = tx[3];
                            expect(isExecuted).to.equal(true);
                            return [4 /*yield*/, erc20Proxy.authorized.callAsync(authorized)];
                        case 6:
                            isAuthorizedAfter = _a.sent();
                            expect(isAuthorizedAfter).to.equal(false);
                            return [2 /*return*/];
                    }
                });
            }); });
            it('should throw if already executed', function () { return __awaiter(_this, void 0, void 0, function () {
                var removeAuthorizedAddressAtIndexData, submitRes, submitLog, txId, execRes, execLog, tx, isExecuted;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            removeAuthorizedAddressAtIndexData = erc20Proxy.removeAuthorizedAddressAtIndex.getABIEncodedTransactionData(authorized, erc20Index);
                            return [4 /*yield*/, assetProxyOwnerWrapper.submitTransactionAsync(erc20Proxy.address, removeAuthorizedAddressAtIndexData, owners[0])];
                        case 1:
                            submitRes = _a.sent();
                            submitLog = submitRes.logs[0];
                            txId = submitLog.args.transactionId;
                            return [4 /*yield*/, assetProxyOwnerWrapper.confirmTransactionAsync(txId, owners[1])];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, assetProxyOwnerWrapper.executeRemoveAuthorizedAddressAtIndexAsync(txId, owners[0])];
                        case 3:
                            execRes = _a.sent();
                            execLog = execRes.logs[1];
                            expect(execLog.args.transactionId).to.be.bignumber.equal(txId);
                            return [4 /*yield*/, testAssetProxyOwner.transactions.callAsync(txId)];
                        case 4:
                            tx = _a.sent();
                            isExecuted = tx[3];
                            expect(isExecuted).to.equal(true);
                            return [2 /*return*/, contracts_test_utils_1.expectTransactionFailedWithoutReasonAsync(testAssetProxyOwner.executeRemoveAuthorizedAddressAtIndex.sendTransactionAsync(txId, {
                                    from: owners[1],
                                }))];
                    }
                });
            }); });
        });
    });
});
// tslint:disable-line max-file-line-count
//# sourceMappingURL=asset_proxy_owner.js.map