import { BigNumber } from '@0x/utils';
import { Provider, TransactionReceiptWithDecodedLogs } from 'ethereum-types';
import { AssetProxyOwnerContract } from '../../generated-wrappers/asset_proxy_owner';
export declare class AssetProxyOwnerWrapper {
    private readonly _assetProxyOwner;
    private readonly _web3Wrapper;
    private readonly _logDecoder;
    constructor(assetproxyOwnerContract: AssetProxyOwnerContract, provider: Provider);
    submitTransactionAsync(destination: string, data: string, from: string, opts?: {
        value?: BigNumber;
    }): Promise<TransactionReceiptWithDecodedLogs>;
    confirmTransactionAsync(txId: BigNumber, from: string): Promise<TransactionReceiptWithDecodedLogs>;
    revokeConfirmationAsync(txId: BigNumber, from: string): Promise<TransactionReceiptWithDecodedLogs>;
    executeTransactionAsync(txId: BigNumber, from: string, opts?: {
        gas?: number;
    }): Promise<TransactionReceiptWithDecodedLogs>;
    executeRemoveAuthorizedAddressAtIndexAsync(txId: BigNumber, from: string): Promise<TransactionReceiptWithDecodedLogs>;
}
//# sourceMappingURL=asset_proxy_owner_wrapper.d.ts.map