"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var contracts_test_utils_1 = require("@0x/contracts-test-utils");
var contracts_tokens_1 = require("@0x/contracts-tokens");
var utils_1 = require("@0x/utils");
var web3_wrapper_1 = require("@0x/web3-wrapper");
var _ = require("lodash");
var artifacts_1 = require("../../src/artifacts");
var AssetProxyOwnerWrapper = /** @class */ (function () {
    function AssetProxyOwnerWrapper(assetproxyOwnerContract, provider) {
        this._assetProxyOwner = assetproxyOwnerContract;
        this._web3Wrapper = new web3_wrapper_1.Web3Wrapper(provider);
        this._logDecoder = new contracts_test_utils_1.LogDecoder(this._web3Wrapper, __assign({}, artifacts_1.artifacts, contracts_tokens_1.artifacts));
    }
    AssetProxyOwnerWrapper.prototype.submitTransactionAsync = function (destination, data, from, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var value, txHash, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        value = _.isUndefined(opts.value) ? new utils_1.BigNumber(0) : opts.value;
                        return [4 /*yield*/, this._assetProxyOwner.submitTransaction.sendTransactionAsync(destination, value, data, {
                                from: from,
                            })];
                    case 1:
                        txHash = _a.sent();
                        return [4 /*yield*/, this._logDecoder.getTxWithDecodedLogsAsync(txHash)];
                    case 2:
                        tx = _a.sent();
                        return [2 /*return*/, tx];
                }
            });
        });
    };
    AssetProxyOwnerWrapper.prototype.confirmTransactionAsync = function (txId, from) {
        return __awaiter(this, void 0, void 0, function () {
            var txHash, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._assetProxyOwner.confirmTransaction.sendTransactionAsync(txId, { from: from })];
                    case 1:
                        txHash = _a.sent();
                        return [4 /*yield*/, this._logDecoder.getTxWithDecodedLogsAsync(txHash)];
                    case 2:
                        tx = _a.sent();
                        return [2 /*return*/, tx];
                }
            });
        });
    };
    AssetProxyOwnerWrapper.prototype.revokeConfirmationAsync = function (txId, from) {
        return __awaiter(this, void 0, void 0, function () {
            var txHash, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._assetProxyOwner.revokeConfirmation.sendTransactionAsync(txId, { from: from })];
                    case 1:
                        txHash = _a.sent();
                        return [4 /*yield*/, this._logDecoder.getTxWithDecodedLogsAsync(txHash)];
                    case 2:
                        tx = _a.sent();
                        return [2 /*return*/, tx];
                }
            });
        });
    };
    AssetProxyOwnerWrapper.prototype.executeTransactionAsync = function (txId, from, opts) {
        if (opts === void 0) { opts = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var txHash, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this._assetProxyOwner.executeTransaction.sendTransactionAsync(txId, {
                            from: from,
                            gas: opts.gas,
                        })];
                    case 1:
                        txHash = _a.sent();
                        return [4 /*yield*/, this._logDecoder.getTxWithDecodedLogsAsync(txHash)];
                    case 2:
                        tx = _a.sent();
                        return [2 /*return*/, tx];
                }
            });
        });
    };
    AssetProxyOwnerWrapper.prototype.executeRemoveAuthorizedAddressAtIndexAsync = function (txId, from) {
        return __awaiter(this, void 0, void 0, function () {
            var txHash, tx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this
                            ._assetProxyOwner.executeRemoveAuthorizedAddressAtIndex.sendTransactionAsync(txId, {
                            from: from,
                        })];
                    case 1:
                        txHash = _a.sent();
                        return [4 /*yield*/, this._logDecoder.getTxWithDecodedLogsAsync(txHash)];
                    case 2:
                        tx = _a.sent();
                        return [2 /*return*/, tx];
                }
            });
        });
    };
    return AssetProxyOwnerWrapper;
}());
exports.AssetProxyOwnerWrapper = AssetProxyOwnerWrapper;
//# sourceMappingURL=asset_proxy_owner_wrapper.js.map